(******************************************************************************)
(* EBNF scanner (inspired by Wirth's PL/0 scanner)                            *)
(* (C) 2011 Steffen Solyga <solyga@absinth.net>                               *)
(******************************************************************************)
DEFINITION MODULE Scnr;

IMPORT FIO;

TYPE
  TSymbol = (
    sId, sLit, (* have val *)
    sLPar, sLBrk, sLBrc,
    sBar, sEql,
    sRBrc, sRBrk, sRPar,
    sDot,
    sInv,
    sEOF
  );

  TPosDesc = RECORD
    l,c: CARDINAL;
  END;

VAR
  src: FIO.File;
  pos: TPosDesc;

  sym: TSymbol;
  val: CARDINAL;


PROCEDURE Read();

PROCEDURE Keep();
PROCEDURE Diff( x, y: CARDINAL ): INTEGER;

(* debug *)
PROCEDURE WrVal( f: FIO.File; val: CARDINAL );
PROCEDURE WrAll( f: FIO.File );
PROCEDURE Dump( f: FIO.File );

END Scnr.
